<template>
  <div class="app-container">
    <el-form
      v-show="showSearch"
      ref="queryRef"
      :inline="true"
      :model="queryParams"
      label-width="68px"
    >
      <el-form-item label="告警名称" prop="alertName">
        <el-input
          v-model="queryParams.alertName"
          clearable
          placeholder="请输入告警名称"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="告警级别" prop="alertLevel">
        <el-input
          v-model="queryParams.alertLevel"
          clearable
          placeholder="请输入告警级别"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="产品ID" prop="productId">
        <el-input
          v-model="queryParams.productId"
          clearable
          placeholder="请输入产品ID"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="设备ID" prop="deviceId">
        <el-input
          v-model="queryParams.deviceId"
          clearable
          placeholder="请输入设备ID"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="租户ID" prop="tenantId">
        <el-input
          v-model="queryParams.tenantId"
          clearable
          placeholder="请输入租户ID"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="用户ID" prop="userId">
        <el-input
          v-model="queryParams.userId"
          clearable
          placeholder="请输入用户ID"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="Search" type="primary" @click="handleQuery"
          >搜索
        </el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alertLog:add']"
          icon="Plus"
          plain
          type="primary"
          @click="handleAdd"
          >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alertLog:edit']"
          :disabled="single"
          icon="Edit"
          plain
          type="success"
          @click="handleUpdate"
          >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alertLog:remove']"
          :disabled="multiple"
          icon="Delete"
          plain
          type="danger"
          @click="handleDelete"
          >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['device:alertLog:export']"
          icon="Download"
          plain
          type="warning"
          @click="handleExport"
          >导出
        </el-button>
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="alertLogList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column align="center" type="selection" width="55" />
      <el-table-column align="center" label="告警ID" prop="alertLogId" />
      <el-table-column align="center" label="告警名称" prop="alertName" />
      <el-table-column align="center" label="告警级别" prop="alertLevel" />
      <el-table-column
        align="center"
        label="处理状态(1不需要处理 2=未处理 3已处理)"
        prop="status"
      />
      <el-table-column align="center" label="产品ID" prop="productId" />
      <el-table-column align="center" label="设备ID" prop="deviceId" />
      <el-table-column align="center" label="租户ID" prop="tenantId" />
      <el-table-column align="center" label="用户ID" prop="userId" />
      <el-table-column align="center" label="备注" prop="remark" />
      <el-table-column align="center" label="类型" prop="type" />
      <el-table-column
        align="center"
        class-name="small-padding fixed-width"
        label="操作"
      >
        <template #default="scope">
          <el-button
            v-hasPermi="['device:alertLog:edit']"
            icon="Edit"
            link
            type="primary"
            @click="handleUpdate(scope.row)"
            >修改
          </el-button>
          <el-button
            v-hasPermi="['device:alertLog:remove']"
            icon="Delete"
            link
            type="primary"
            @click="handleDelete(scope.row)"
            >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:limit="queryParams.pageSize"
      v-model:page="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改设备告警日志对话框 -->
    <el-dialog v-model="open" :title="title" append-to-body width="500px">
      <el-form
        ref="alertLogRef"
        :model="form"
        :rules="rules"
        label-width="80px"
      >
        <el-form-item label="告警名称" prop="alertName">
          <el-input v-model="form.alertName" placeholder="请输入告警名称" />
        </el-form-item>
        <el-form-item label="告警级别" prop="alertLevel">
          <el-input v-model="form.alertLevel" placeholder="请输入告警级别" />
        </el-form-item>
        <el-form-item label="产品ID" prop="productId">
          <el-input v-model="form.productId" placeholder="请输入产品ID" />
        </el-form-item>
        <el-form-item label="设备ID" prop="deviceId">
          <el-input v-model="form.deviceId" placeholder="请输入设备ID" />
        </el-form-item>
        <el-form-item label="租户ID" prop="tenantId">
          <el-input v-model="form.tenantId" placeholder="请输入租户ID" />
        </el-form-item>
        <el-form-item label="用户ID" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入用户ID" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            v-model="form.remark"
            placeholder="请输入内容"
            type="textarea"
          />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script name="AlertLog" setup>
import {
  addAlertLog,
  delAlertLog,
  getAlertLog,
  listAlertLog,
  updateAlertLog,
} from "@/api/device/alertLog";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const alertLogList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    alertName: null,
    alertLevel: null,
    status: null,
    productId: null,
    deviceId: null,
    tenantId: null,
    userId: null,
    type: null,
  },
  rules: {
    alertName: [
      { required: true, message: "告警名称不能为空", trigger: "blur" },
    ],
    alertLevel: [
      { required: true, message: "告警级别不能为空", trigger: "blur" },
    ],
    status: [
      {
        required: true,
        message: "处理状态(1不需要处理 2=未处理 3已处理)不能为空",
        trigger: "change",
      },
    ],
  },
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备告警日志列表 */
function getList() {
  loading.value = true;
  listAlertLog(queryParams.value).then((response) => {
    alertLogList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    alertLogId: null,
    alertName: null,
    alertLevel: null,
    status: null,
    productId: null,
    deviceId: null,
    tenantId: null,
    userId: null,
    remark: null,
    type: null,
    createBy: null,
    createTime: null,
  };
  proxy.resetForm("alertLogRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.alertLogId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备告警日志";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _alertLogId = row.alertLogId || ids.value;
  getAlertLog(_alertLogId).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改设备告警日志";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["alertLogRef"].validate((valid) => {
    if (valid) {
      if (form.value.alertLogId != null) {
        updateAlertLog(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addAlertLog(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _alertLogIds = row.alertLogId || ids.value;
  proxy.$modal
    .confirm('是否确认删除设备告警日志编号为"' + _alertLogIds + '"的数据项？')
    .then(function () {
      return delAlertLog(_alertLogIds);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "device/alertLog/export",
    {
      ...queryParams.value,
    },
    `alertLog_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
